#!/usr/bin/perl

srand();

if ($#ARGV == -1) {
	if (-t 0) {
		select(STDOUT);
		$| = 1;
		system("stty -echo");
		print "New password: ";
		$typed1=<STDIN>;
		print "\nAgain: ";
		$typed2=<STDIN>;
		print "\n";
		system("stty echo");
		if ($typed1 ne $typed2) {
			printf("Mismatch\n");
			exit(1);
		}
		mkpass($typed1, 0);
		exit(0);
	}
	while ($typed=<>) {
		mkpass($typed, 1);
	}
}

foreach $typed (@ARGV) {
	mkpass($typed, 1);
}

sub mkpass() {
	local($pass, $print)=@_;

	chomp($pass);
	$salt=rndsalt().rndsalt();
	if ($print) {
		print "$pass ";
	}
	print crypt($pass, $salt), "\n";
}

sub rndsalt() {
	$i=int(rand(64));
	if ($i < 26) {
		return chr($i+ord("a"));
	}
	$i -= 26;
	if ($i < 26) {
		return chr($i+ord("A"));
	}
	$i -= 26;
	if ($i < 10) {
		return chr($i+ord("0"));
	}
	$i -= 10;

	return $i?"/":".";
}
